import java.math.* ;
import java.io.* ;
/*
  QS

 Luc Maranget, projet Moscova, Inria Rocquencourt
 
 Copyright 2005 Institut National de Recherche en Informatique et    
 en Automatique.  All rights reserved.  This file is distributed     
 under the terms of the Q Public License version 1.0.          
*/
class Gauss {

  public static void main(String [] arg) {
    Reader reader = null ;

    if (arg.length > 0) {
      try {
        reader = new BufferedReader (new FileReader (arg[0])) ;
      } catch (IOException e) {
        System.err.println(e.getMessage()) ;
        System.exit(2) ;
        return ;
      }
    } else {
      reader = new BufferedReader (new InputStreamReader (System.in)) ;
    }

    Eqs eqs = new Parse(reader).eqs() ;
    Row [] mat = eqs.makeMatrix() ;
    Row.solve(mat, eqs) ;
  }
}
